#ifndef XMIT_FILE_H
#define XMIT_FILE_H
#include "mpi.h"

enum {
    XF_SUCCESS = 0,
    XF_XMITERR = -1,
    XF_FILEERR = -2,
    XF_INTNERR = -3
};

extern int compression_init();
extern int Send_file_fd(int fd, int dest, int tag, MPI_Comm comm);
extern int Send_file(char *filename, int dest, int tag, MPI_Comm comm);
extern int Send_file_tar(char *filename, int dest, int tag, MPI_Comm comm);

extern int Recv_file_fd(int fd, int source, int tag, MPI_Comm comm);
extern int Recv_file(char *filename, int fn_len, int source, int tag, MPI_Comm comm);
extern int Recv_file_tar(int source, int tag, MPI_Comm comm);

#define MAX_DIR_DEPTH           32

#define BCAST_RETRY 	        (1 << 0)
#define BCAST_VERBOSE	       	(1 << 1)
#define BCAST_RECURSIVE         (1 << 2)
#define BCAST_PRESERVE_LINKS    (1 << 3)
#define BCAST_PRESERVE_MODE     (1 << 4)
#define BCAST_PRESERVE_SPECIAL  (1 << 5)
#define BCAST_FORCE             (1 << 6)
#define BCAST_NO_CHECKING       (1 << 7)
#define BCAST_NO_TAR            (1 << 8)
#define BCAST_FORCE_TAR         (1 << 9)
#define BCAST_NO_COMPRESSION    (1 << 10)
#define BCAST_FORCE_COMPRESSION (1 << 11)

#define MAX_RETRIES		3
extern int Bcast_file_fd(int fd, int flags, int root, MPI_Comm comm);
extern int Bcast_file(char *src, char *dest, int flags, int root, MPI_Comm comm);
extern int Bcast_file_tar(char *src, char *dest, int flags, int root, MPI_Comm comm);

#endif /* XMIT_FILE_H */
